# https://git.syndicate-lang.org/synit/synit/src/branch/main/packaging/packages/synit-pid1/APKBUILD

{ lib, rustPlatform, rust, fetchFromGitea }:

rustPlatform.buildRustPackage rec {
  pname = "synit-pid1";
  version = "unstable-2023-02-07";
  src = fetchFromGitea {
    domain = "git.syndicate-lang.org";
    owner = "synit";
    repo = "synit";
    rev = "69637cb27a1a3a900ff1d647e814206b0ca66ca5";
    hash = "sha256-VVMttlRIiH/aGytC9CutoaT0YDGkCGhO3GbipYXk3dg=";
  };

  patchPhase =
    # Patch to take children and configuration from /run/booted-system.
    ''
      runHook prePatch
      substituteInPlace src/main.rs \
        --replace '"/usr/bin/syndicate-server"' '"/run/booted-system/sw/bin/syndicate-server"' \
        --replace '"/sbin/synit-log"' '"/run/booted-system/sw/bin/synit-log"' \
        --replace '"/etc/syndicate/boot"' '"/run/booted-system/etc/syndicate/boot"' \

      runHook postPatch
    '';

  sourceRoot = "source/${pname}";
  cargoHash = "sha256-57ZUlR+lIwQf3/4pDeeEMUc1juNTddcHpzNQZTUWbtU=";
  nativeBuildInputs = [ rust ];

  meta = src.meta // {
    description = "Synit pid 1 program (patched for NixOS)";
    homepage = "https://synit.org/";
    maintainers = with lib.maintainers; [ ehmry ];
  };
}
